/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002 Roberto Lopez <roblez@ciudad.com.ar>
 * http://www.geocities.com/harbour_minigui/
*/

* Enjoy !

#include "minigui.ch"

Function Main
	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 480 ;
		TITLE 'Demostracion de Menu con Colores' ;
		MAIN NOMAXIMIZE ON INIT cMenu()

//        @ 0, 0 IMAGE xxI Picture "BLUSTONE.BMP" Width Form_1.Width Height Form_1.Height STRETCH

		DEFINE MAIN MENU 
			POPUP ' Archivos'
				ITEM ' Bancos  '	             ACTION MsgInfo(" Mantenimiento de Entidades Bancarias ")
				ITEM ' Cuentas Bancarias '	     ACTION MsgInfo(" Mantenimientos de Cuentas Bancarias ")
				ITEM ' Tipo de Transacciones '   ACTION MsgInfo("Mantenimiento de Tipos de Transacciones ")
				SEPARATOR
				ITEM ' Beneficiarios '		     ACTION MsgInfo(" Mantenimiento de Beneficiarios ")
				SEPARATOR
				ITEM ' Salida '	                 ACTION Form_1.Release
			END POPUP
			POPUP ' Transacciones '
				ITEM ' Movimientos '		     ACTION MsgInfo(" Movimientos Bancarios") 
				SEPARATOR
				ITEM ' Emision de Cheques '	 	 ACTION MsgInfo(" Emision de Cheques a Beneficiarios") 
				SEPARATOR
				ITEM ' Conciliacion de Cuentas ' ACTION MsgInfo(" Emision de Cheques a Beneficiarios") 
			END POPUP

			POPUP ' Reportes '
				ITEM 'About'		ACTION MsgInfo ("MiniGUI Browse Demo") 
				SEPARATOR
				ITEM ' Movimientos de Cuentas         '	ACTION MsgInfo(" Reportes")
				ITEM ' Conciliaciones de Cuentas      '	ACTION MsgInfo(" Reportes")
				ITEM ' Consultas de Cuentas Resumidas '	ACTION MsgInfo(" Reportes")
			END POPUP

			POPUP ' Utilidades '
				ITEM ' Interface con ELITE         '	ACTION MsgInfo(" ELITE")
				ITEM ' Conciliaciones de Cuentas   '	ACTION MsgInfo(" CUENTAS")
				ITEM ' Reconstruccion de Indices '	ACTION MsgInfo(" Recosntruccion de Indices")
			END POPUP


            @10,10  Button BtnColor Caption " Seleccione un Color " Action ColorMenu() Width 150

            @10,200 Button BtnImage Caption " Seleccione una Imagen " Action ImageMenu() Width 150

            @50,200 Image ImgTest picture "BLUSTONE.BMP" Stretch


		END MENU
	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return Nil

Return Nil

Func CMenu()
 Local hMenu    := _GetMenuId(GetFormHandle("Form_1"))
 Local aColor   := {255,255,255}
 Local lSubMenu := .t.
 _ColorMenu(GetFormHandle("Form_1"),aColor, lSubMenu,, "BLUSTONE.BMP")
Return Nil

Func ColorMenu()
 Local hMenu    := _GetMenuId(GetFormHandle("Form_1"))
 Local lSubMenu := .t.
 Local aColor   :=GetColor()
 Local aBr := GetControlHandle("ImgTest","Form_1")
 If aColor[1] = Nil
   MsgInfo(" No Selecciono Color ")
 Else
   _ColorMenu(GetFormHandle("Form_1"),aColor, lSubMenu, )
 EndIf
Return Nil

Func ImageMenu()
 Local hMenu    := _GetMenuId(GetFormHandle("Form_1"))
 Local lSubMenu := .t.
 Local aImage   := GetFile(	{ {'BITMAP','*.Bmp'} } , 'Abrir Archivos Bitmap' ,  , .f. , .t. )
 Local aBr := GetControlHandle("ImgTest","Form_1")
 If Empty(aImage)
   MsgInfo(" No Selecciono Imagen ")
 Else
   _ColorMenu(GetFormHandle("Form_1"),, lSubMenu, aImage)
  SetProperty("Form_1","ImgTest","picture",aImage)
 EndIf
Return Nil




#pragma BEGINDUMP
#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"
#include "winreg.h"
#include "tchar.h"

HB_FUNC( _GETMENUID)
{
 hb_retnl((LONG)GetMenu((HWND)hb_parnl(1)));
}

HB_FUNC ( _COLORMENU )
{
HMENU      iMenu;
MENUINFO   iMenuInfo ;
INT   nRed   = hb_parni(2,1);
INT   nGreen = hb_parni(2,2);
INT   nBlue  = hb_parni(2,3);
BOOL  lSubMenu = hb_parl(3);
HWND  himage ;

himage = (HWND)LoadImage(0,hb_parc(4),IMAGE_BITMAP ,0,0,LR_LOADFROMFILE | LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );

if (himage==NULL)
  {
	himage = (HWND)LoadImage(GetModuleHandle(NULL),hb_parc(4),IMAGE_BITMAP ,0,0, LR_LOADMAP3DCOLORS	| LR_LOADTRANSPARENT );
  }

iMenu              = GetMenu((HWND) hb_parnl(1));
GetMenuInfo(iMenu, &iMenuInfo);
iMenuInfo.cbSize   = sizeof(MENUINFO);

if (lSubMenu)
 {
   iMenuInfo.fMask    = MIM_BACKGROUND | MIM_APPLYTOSUBMENUS ;
 }
else
 {
   iMenuInfo.fMask    = MIM_BACKGROUND;
 }

if (himage==NULL)
 {
    iMenuInfo.hbrBack = CreateSolidBrush(RGB(nRed, nGreen, nBlue));
 }
else
 {
    iMenuInfo.hbrBack = CreatePatternBrush(himage);
 }

SetMenuInfo(iMenu, &iMenuInfo);
DrawMenuBar((HWND) hb_parnl(1));

}

HB_FUNC ( _COLORSUBMENU )
{
HMENU      iMenu;
MENUINFO   iMenuInfo ;
iMenu              = GetMenu((HWND) hb_parnl(1));
GetMenuInfo(iMenu, &iMenuInfo);
iMenuInfo.cbSize   = sizeof(MENUINFO);
iMenuInfo.fMask    = MIM_BACKGROUND | MIM_APPLYTOSUBMENUS;
iMenuInfo.hbrBack  = CreateSolidBrush(RGB(hb_parni(2,1),hb_parni(2,2),hb_parni(2,3)));
SetMenuInfo(iMenu, &iMenuInfo);
DrawMenuBar((HWND) hb_parnl(1));
}
#pragma ENDDUMP

